#!/system/bin/sh

# NO WARRANTY OF ANY KIND. USE AT YOUR OWN RISK!

# tested on LG MS50012b

PARTITION1="/dev/block/vold/179:33"
PARTITION2="/dev/block/vold/179:34"
TMP_DIR="/cache/data_tmp"
MOUNT_OPT=nosuid,nodev,noauto_da_alloc,resuid=1000,errors=continue
VALID_TAG=".LGF6DataOnSD_DO_NOT_REMOVE"
INIT_TAG=".LGF6DataOnSD_INIT"

if [[ -f /data/$VALID_TAG ]]; then
  exit 0
fi
if [[ -b $PARTITION2 ]] && [[ ! -d $TMP_DIR ]]; then
  mkdir $TMP_DIR
  mount -t ext4 -o $MOUNT_OPT $PARTITION2 $TMP_DIR
  if [[ "$?" = "0" ]]; then
    if [[ -f $TMP_DIR/$VALID_TAG ]] && [[ -d $TMP_DIR/dalvik-cache ]]; then
      mount -t ext4 -o $MOUNT_OPT $PARTITION2 /data
    else
      mount -t vfat $PARTITION1 $TMP_DIR
      if [[ "$?" = "0" ]]; then
        if [[ -f $TMP_DIR/$INIT_TAG ]]; then
          rm $TMP_DIR/$INIT_TAG
          umount $TMP_DIR
          rm -r $TMP_DIR/*
          rm -r $TMP_DIR/.*
          cp -a /data/. $TMP_DIR
          touch $TMP_DIR/$VALID_TAG
          mount -t ext4 -o $MOUNT_OPT $PARTITION2 /data
        else
          umount $TMP_DIR
        fi
      fi
    fi
    umount $TMP_DIR
  fi
  rmdir $TMP_DIR
fi

